VERSION 5.00
Begin VB.Form frmMain 
   ClientHeight    =   4635
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   5520
   LinkTopic       =   "Form1"
   ScaleHeight     =   4635
   ScaleWidth      =   5520
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRun 
      Caption         =   "Start"
      Height          =   855
      Left            =   1800
      TabIndex        =   0
      Top             =   1440
      Width           =   2055
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 0

Private Const PAGE_EXECUTE_READWRITE As Long = &H40&
Private Const MEM_RESERVE            As Long = &H2000&
Private Const MEM_COMMIT             As Long = &H1000&
Private Const MEM_RELEASE            As Long = &H8000&

Private Const TOTAL_ELEMENTS         As Long = 4000000
Private Const TOTAL_REPEATS          As Long = 20

Private Declare Function allmul Lib "ntdll" _
                         Alias "_allmul" ( _
                         ByVal cMultiplicand As Currency, _
                         ByVal cMultiplier As Currency) As Currency
Private Declare Function VirtualAlloc Lib "kernel32" ( _
                         ByVal lpAddress As Long, _
                         ByVal dwSize As Long, _
                         ByVal flAllocationType As Long, _
                         ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" ( _
                         ByVal lpAddress As Long, _
                         ByVal dwSize As Long, _
                         ByVal dwFreeType As Long) As Long
Private Declare Function QueryPerformanceCounter Lib "kernel32" ( _
                         ByRef lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" ( _
                         ByRef lpFrequency As Currency) As Long
Private Declare Sub PutMem8 Lib "msvbvm60" ( _
                    ByRef pAddr As Any, _
                    ByVal cVal As Currency)

Private Sub cmdRun_Click()
    Dim cFreq       As Currency
    Dim cStart      As Currency
    Dim cEnd        As Currency
    Dim sResult     As String
    Dim cA()        As Currency
    Dim cB()        As Currency
    Dim cA_ref()    As Currency
    Dim cB_ref()    As Currency
    Dim cResult     As Currency
    Dim pThunk      As Long
    Dim lIndex      As Long
    Dim lPass       As Long
    Dim lOverflow   As Long
    
    QueryPerformanceFrequency cFreq
    
    PatchFunc AddressOf CallMul64

    ReDim cA_ref(TOTAL_ELEMENTS - 1)
    ReDim cB_ref(TOTAL_ELEMENTS - 1)
    
    For lIndex = 0 To TOTAL_ELEMENTS - 1
        cA_ref(lIndex) = Rnd * 123124
        cB_ref(lIndex) = Rnd * 123124
    Next
    
    pThunk = VirtualAlloc(0, 4096, MEM_RESERVE Or MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    If (pThunk = 0) Then
        Err.Raise 7
    End If
    
    PutMem8 ByVal pThunk + &H0, 58673075381837.9403@:    PutMem8 ByVal pThunk + &H8, -841400200908515.2256@
    PutMem8 ByVal pThunk + &H10, -151091765892270.3804@: PutMem8 ByVal pThunk + &H18, 261336656082321.5378@
    PutMem8 ByVal pThunk + &H20, -64206745947098.5468@:  PutMem8 ByVal pThunk + &H28, -856712431910701.3532@
    PutMem8 ByVal pThunk + &H30, 262249248019687.3153@:  PutMem8 ByVal pThunk + &H38, 261561837347209.2428@
    PutMem8 ByVal pThunk + &H40, -446757083035141.5532@: PutMem8 ByVal pThunk + &H48, 12809326053890.4596@
    PutMem8 ByVal pThunk + &H50, 2282345621.0945@:
    
    cA = cA_ref
    cB = cB_ref
    
    QueryPerformanceCounter cStart
    
    For lPass = 0 To TOTAL_REPEATS - 1
        For lIndex = 0 To TOTAL_ELEMENTS - 1
            cA(lIndex) = CallMul64(pThunk, cA(lIndex), cB(lIndex), lOverflow)
        Next
    Next
    
    QueryPerformanceCounter cEnd
    
    sResult = "mul64: " & Format$((cEnd - cStart) / cFreq, "0.00000") & "s" & vbNewLine

    PutMem8 ByVal pThunk + &H0, 108428148711222.1011@: PutMem8 ByVal pThunk + &H8, -59188793359677.0118@
    PutMem8 ByVal pThunk + &H10, -857143608150326.3652@: PutMem8 ByVal pThunk + &H18, 145136034483615.4444@
    PutMem8 ByVal pThunk + &H20, -394935621207348.1713@: PutMem8 ByVal pThunk + &H28, 145136865903878.8855@
    PutMem8 ByVal pThunk + &H30, -895075333820512.3447@: PutMem8 ByVal pThunk + &H38, -457423395514507.9684@
    PutMem8 ByVal pThunk + &H40, 727530147099517.6565@: PutMem8 ByVal pThunk + &H48, 75372019043500.3428@
    PutMem8 ByVal pThunk + &H50, 116316561592472.4875@: PutMem8 ByVal pThunk + &H58, 449966793010230.6027@
    PutMem8 ByVal pThunk + &H60, 727529267490218.0233@: PutMem8 ByVal pThunk + &H68, 140320602847609.2452@
    PutMem8 ByVal pThunk + &H70, 27543267008.5253@: PutMem8 ByVal pThunk + &H78, 843123543932177.6128@
    PutMem8 ByVal pThunk + &H80, 60911379076113.4855@: PutMem8 ByVal pThunk + &H88, -388383464486392.3919@
    PutMem8 ByVal pThunk + &H90, 195461515.1755@: PutMem8 ByVal pThunk + &H98, 551550225780539.392@
    PutMem8 ByVal pThunk + &HA0, 432479.2356@: PutMem8 ByVal pThunk + &HA8, 136.0475@

    cA = cA_ref
    cB = cB_ref
    
    QueryPerformanceCounter cStart
    
    For lPass = 0 To TOTAL_REPEATS - 1
        For lIndex = 0 To TOTAL_ELEMENTS - 1
            cA(lIndex) = CallMul64(pThunk, cA(lIndex), cB(lIndex), lOverflow)
        Next
    Next
    
    QueryPerformanceCounter cEnd
    
    sResult = sResult & "imul64: " & Format$((cEnd - cStart) / cFreq, "0.00000") & "s" & vbNewLine
    
    cA = cA_ref
    cB = cB_ref

    QueryPerformanceCounter cStart
    
    For lPass = 0 To TOTAL_REPEATS - 1
        For lIndex = 0 To TOTAL_ELEMENTS - 1
            cA(lIndex) = allmul(cA(lIndex), cB(lIndex))
        Next
    Next
    
    QueryPerformanceCounter cEnd
    
    sResult = sResult & "allmul: " & Format$((cEnd - cStart) / cFreq, "0.00000") & "s" & vbNewLine
    
    VirtualFree pThunk, 0, MEM_RELEASE
    
    MsgBox sResult
    
End Sub

